﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Diagnostics;
using Infragistics.Windows.DataPresenter;
using System.Collections.ObjectModel;
using System.ComponentModel;
using Infragistics.Windows;

namespace XamDataGridBinding
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window,INotifyPropertyChanged
    {
        bool loaded = false;

        Random rand = new Random();

        private ObservableCollection<Userdata> _CollectionList = default(ObservableCollection<Userdata>);

        public ObservableCollection<Userdata> CollectionList
        {
            get { return _CollectionList; }
            set { _CollectionList = value; }
        }

        private string _LabelText;

        public string LabelText
        {
            get { return _LabelText; }
            set { _LabelText = value; }
        }


        public MainWindow()
        {
            InitializeComponent();
            LabelText = "Loading the Text........";
            OnPropertyChanged("LabelText");
            CollectionList = new ObservableCollection<Userdata>();
            CollectionList.Add(new Userdata() { FirstName = "Prakash", LastName = "G", Car = "I10" });
            CollectionList.Add(new Userdata() { FirstName = "Prasanth", LastName = "G", Car = "ZEN" });
            CollectionList.Add(new Userdata() { FirstName = "Ashwin", LastName = "S", Car = "SX4" });
            CollectionList.Add(new Userdata() { FirstName = "Samyak", LastName = "G", Car = "FERARI" });
            DataContext = this;
        }

        void Load(object sender, RoutedEventArgs e)
        {
            var collection = (sender as DataRecordPresenter).Record.DataPresenter.Records;

            if ((sender as DataRecordPresenter).Record.IsSpecialRecord == false && (sender as DataRecordPresenter).Record.Index == 0 && loaded == false)
            {
                Debug.WriteLine("Finished");
                loaded = true;
                LabelText = default(string);
                OnPropertyChanged("LabelText");
            }
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                LabelText = "Loading the Text........";
                OnPropertyChanged("LabelText");
                loaded = false;
                CollectionList = new ObservableCollection<Userdata>();
                xamDataGrid1.DataItems.Clear();
                for (int i = 0; i < 10; i++)
                {
                    int value = rand.Next(10);
                    CollectionList.Add(new Userdata()
                    {
                        FirstName = "Samyak_" + value.ToString(),
                        LastName = "G_" + value.ToString(),
                        Car = "FERARI_" + value.ToString()
                    });
                }

                OnPropertyChanged("CollectionList");
            }
            catch
            {
                e.Handled = true;
            }

        }

        #region Notify Events
        public event PropertyChangedEventHandler PropertyChanged = default(PropertyChangedEventHandler);
        public void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null) PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
        #endregion
    }

    public class Userdata : INotifyPropertyChanged
    {
        string _LastName;

        public string LastName
        {
            get { return _LastName; }
            set { _LastName = value; OnPropertyChanged("LastName"); }
        }

        string _FirstName;

        public string FirstName
        {
            get { return _FirstName; }
            set { _FirstName = value; OnPropertyChanged("FirstName"); }
        }

        string _Car;

        public string Car
        {
            get { return _Car; }
            set { _Car = value; OnPropertyChanged("Car"); }
        }

        #region Notify Events
        public event PropertyChangedEventHandler PropertyChanged = default(PropertyChangedEventHandler);
        public void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null) PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
        #endregion
    }
}
